Digitals/Controllers/ProductoController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using Digitals.BL;
using Digitals.ET;

namespace Digitals.Controllers
{
    public class ProductoController : Controller
    {
        // GET: Producto

        private ProductoBL productoBL = new ProductoBL();

        public ActionResult Listar()
        {
            return View(productoBL.Listar());
        }

        public ActionResult Detalles(int id)
        {

            return View(productoBL.Obtener(id));

        }

        public ActionResult Crear(Producto producto)
        {
            return View(producto);
        }

        public ActionResult Editar(int id = 0)
        {
            return View(productoBL.Obtener(id));
        }

        [HttpPost]
        public ActionResult Registrar(Producto producto)
        {
            productoBL.Registrar(producto);
            return Redirect("~/Producto/Listar");
        }

        [HttpPost]
        public ActionResult Actualizar(Producto producto)
        {
            productoBL.Actualizar(producto);
            ViewBag.Mensaje = "Actualizado";
            return Redirect("~/Producto/Listar");
        }

        public ActionResult Eliminar(int id)
        {
            var r = productoBL.Eliminar(id);

            if (!r)
            {
                // Podemos validar para mostrar un mensaje personalizado, por ahora el aplicativo se caera por el throw que hay en nuestra capa DAL
                ViewBag.Mensaje = "Ocurrio un error inesperado";
                return View("~/Views/Shared/_Mensaje.cshtml");
            }

            return Redirect("~/Producto/Listar");
        }
    }

}

Digitals/Views/Producto/Crear.cshtml
﻿@model Digitals.ET.Producto


<html>
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
	<meta charset="utf-8" />
	<meta name="viewport" content="width=device-width, initial-scale=1.0">
	<title>@ViewBag.Title</title>
</head>
<body>
	@using (Html.BeginForm("Registrar", "Producto", FormMethod.Post))
	{
		<div class="container-fluid">
			<div class="row">
				<div class="col-md-6">
					<div class="card">
						<h3 class="card-header text-muted"> @(Model.IdProducto > 0 ? Model.Nombre : "Nuevo Registro")</h3>
						<div class="card-body">
							<form>
								<div class="form-group row">
									<div class="form-group col-md-6">
										<label class="control-label col-xs-3 sr-only" for="Nombre">ID: </label>
										<div class="col-xs-9">
											<input class="form-control" disabled="disabled" id="IdProducto" name="IdProducto" type="number" value="" placeholder="ID Producto" />
										</div>
									</div>
									<div class="form-group col-md-6">
										<label class="control-label col-xs-3 sr-only" for="Nombre">Nombre: </label>
										<div class="col-xs-9">
											@Html.TextBoxFor(x => x.Nombre, new { @class = "form-control", placeholder = "Nombre" })
										</div>
									</div>
								</div>
								<div class="form-group">
									<label class="control-label col-xs-3" for="Detalle">Descripción:</label>
									<div class="col-xs-9">
										@Html.TextAreaFor(x => x.Detalle, new { @class = "form-control" })
									</div>
								</div>
								<div class="form-group row">
									<div class="form-group col-md-6">
										<label class="control-label col-xs-3 sr-only" for="Stock">Stock:</label>
										<div class="col-xs-9">
											<input class="form-control" id="Cantidad" name="Cantidad" type="number" value="" placeholder="Cantidad" />
										</div>
									</div>
									<div class="form-group col-md-6">
										<label class="control-label col-xs-3 sr-only" for="Precio">Precio:</label>
										<div class="col-xs-9">
											<input class="form-control" id="Precio" name="Precio" type="text" value="" placeholder="Precio" />
										</div>
									</div>
								</div>
								<br>
								<div class="form-group">
									<div class="col-xs-offset-3 col-xs-9">
										<input type="submit" class="btn btn-primary" value="Registrar">
										<a href="~/Producto/Listar" class="btn btn-success">Volver</a>
									</div>
								</div>
							</form>
						</div>
					</div>
				</div>
			</div>
		</div>
	}
</body>
</html>

Digitals/Views/Producto/Detalles.cshtml
@model Digitals.ET.Producto
@{
	ViewBag.Title = "Detalles";
}

<!DOCTYPE html>
<html>
<head>
	<meta charset="utf-8" />
	<title>Lista de Productos</title>
	<meta name="viewport" content="width=device-width, initial-scale = 1" />
</head>
<body>
	<div class="container-fluid">
<br />
		<div class="row">
			<div class="col-lg-6 col-md-6 col-sm-6 col-xs-6">
				<div class="card mb-3">
					<div class="card-header text-warning"><h3>@Html.DisplayFor(model => model.Nombre)</h3></div>
					<div class="card-body">
						<div class="card-group">
							<label class="text-info col-lg-6">ID del Producto: </label>
							<label class="text-success col-lg-6">@Html.DisplayFor(model => model.IdProducto)</label>
						</div>
						<div class="card-group">
							<label class="text-info col-lg-6">Detalles: </label>
							<label class="text-success col-lg-6">@Html.DisplayFor(model => model.Detalle)</label>
						</div>
						<div class="card-group">
							<label class="text-info col-lg-6">Cantidad: </label>
							<label class="text-success col-lg-6">@Html.DisplayFor(model => model.Cantidad)</label>
						</div>
						<div class="card-group">
							<label class="text-info col-lg-6">Precio: </label>
							<label class="text-success col-lg-6">@Html.DisplayFor(model => model.Precio)</label>
						</div>
					</div>
					<div class="card-footer small text-muted">
						<div class="panel-footer text-muted">
							@Html.ActionLink("Editar", "Editar", new { id = Model.IdProducto }) |
							@Html.ActionLink("Volver", "Listar")
						</div>
					</div>
				</div>
			</div>
		</div>
	</div>
</body>
</html>

Digitals/Views/Producto/Editar.cshtml
@model Digitals.ET.Producto
@{
	ViewBag.Title = "Editar Producto";

}
<!DOCTYPE html>
<html>
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
	<meta charset="utf-8" />
	<meta name="viewport" content="width=device-width, initial-scale=1.0">
	<title>@ViewBag.Title</title>

</head>
<body>
	@using (Html.BeginForm("Actualizar", "Producto", FormMethod.Post))
	{
		<div class="container-fluid">
<br />
<br />
			<div class="row">
				<div class="col-md-8">
					<div class="card">
						<h3 class="card-header text-success">@Model.Nombre</h3>
						<div class="card-body">
							<form>
								<div class="form-group row">
									<div class="form-group col-md-6">
										<label class="text-primary control-label" for="IdProducto">ID: </label>
										<div class="">
											@Html.TextBoxFor(x => x.IdProducto, new { @class = "form-control", @readonly = "readonly" })
										</div>
									</div>
									<div class="form-group col-md-6">
										<label class="text-primary control-label" for="Nombre">Nombre: </label>
										<div class="">
											@Html.TextBoxFor(x => x.Nombre, new { @class = "form-control" })
										</div>
									</div>
								</div>
								<div class="form-group row">
									<div class="form-group col-md-12">
										<label class="text-primary control-label col-xs-3" for="Descripción">Detalle:</label>
										<div class="">
											@Html.TextAreaFor(x => x.Detalle, new { @class = "form-control" })
										</div>
									</div>

									<div class="form-group col-md-3">
										<label class="text-primary control-label col-xs-3" for="Precio">Cantidad:</label>
										<div class="">
											@Html.TextBoxFor(x => x.Cantidad, new { @class = "form-control" })
										</div>
									</div>
									<div class="form-group col-md-3">
										<label class="text-primary control-label col-xs-3" for="Precio">Precio:</label>
										<div class="">
											@Html.TextBoxFor(x => x.Precio, new { @class = "form-control" })
										</div>
									</div>
								</div>
								<br>
								<div class="form-group">
									<div class="col-xs-offset-3 col-xs-9">
										<input type="submit" class="btn btn-primary" value="Actualizar">
										<a href="~/Producto/Listar" class="btn btn-success">Volver</a>
									</div>
								</div>
							</form>
						</div>
					</div>
				</div>
			</div>
		</div>
	}

</body>
</html>

Digitals/Views/Producto/Listar.cshtml
@model List<Digitals.ET.Producto>

@{
	ViewBag.Title = "Productos";
}

<html>
<head>
	<meta charset="utf-8" />
	<title>Lista de Productos</title>
	<meta name="viewport" content="width=device-width, initial-scale = 1" />
</head>
<body>
	<br />
	<br />
	<div class="container-fluid">
		<div class="card mb-3">
			<div class="card-header">
				<a title="Editar" href="~/Producto/Crear"><i class="fa fa-fw fa fa-plus-circle"></i>   Nuevo Producto  </a>
			</div>
			<br />
			<div class="card-body">
				<div class="table-responsive">
					<table class="table table-bordered" width="100%" cellspacing="0">
						<thead>
							<tr>
								<th>ID</th>
								<th>Nombre</th>
								<th>Detalle</th>
								<th>Cantidad</th>
								<th>Precio</th>
								<th>Acción</th>
							</tr>
						</thead>
						<tbody>
							@foreach (var item in Model)
							{
							<tr>
								<td>
									@Html.DisplayFor(modelItem => item.IdProducto)
								</td>
								<td>
									@Html.DisplayFor(modelItem => item.Nombre)
								</td>
								<td>
									@Html.DisplayFor(modelItem => item.Detalle)
								</td>
								<td>
									@Html.DisplayFor(modelItem => item.Cantidad)
								</td>
								<td>
									@Html.DisplayFor(modelItem => item.Precio)
								</td>
								<td>
									<a title="Editar" href="~/Producto/Editar/@item.IdProducto">Editar </a> |
									<a title="Detalles" href="~/Producto/Detalles/@item.IdProducto">Ver </a> |
									<a title="Eliminar" onclick="return confirm('¿Esta seguro de Eliminar este Registro?');" href="~/Producto/Eliminar/@item.IdProducto">Eliminar</a>
								</td>
							</tr>
							}
						</tbody>
					</table>
				</div>
			</div>
		</div>
	</div>




</body>
</html>